#include <string>
#include <list>

using std::string;
using std::list;

#include "classes.hh"

class Kick
{
    defclassvar(string, nick, const string &, getnick)
    defclassvar(string, parm, const string &, getparm)
public:
    Kick(const string &k, const string &p): nick(k), parm(p) { }
    
    void setparm(const string &s);
    
    bool operator== (const Kick &b) const;
    inline bool operator!= (const Kick &b) const { return ! operator==(b); }
    
    static char cmdchar() { return 'K'; }
    static unsigned groupcount() { return 0; }
    static bool needsparm() { return false; }
    bool compatible(const Kick &b) const;
    
    void dump() const;
};

extern string strgroup(const list<Kick> &);
