#include <string>
#include <list>

using std::string;
using std::list;

#include "classes.hh"

class Topic
{
    defclassvar(string, parm, const string &, getparm)
public:
    Topic(const string &p): parm(p) { }
    
    void setparm(const string &s);
    
    bool operator== (const Topic &b) const;
    inline bool operator!= (const Topic &b) const { return ! operator==(b); }
    
    static char cmdchar() { return 'T'; }
    static unsigned groupcount() { return 1; }
    static bool needsparm() { return true; }
    bool compatible(const Topic &b) const;
    
    void dump() const;
};

extern string strgroup(const list<Topic> &);
